#include <stdio.h>
#include <stdlib.h>
#include "hex.h"


grid *newGrid(void)
{
grid *g;
if ( (g=(grid *)malloc(sizeof(grid))) == NULL ) error("Out of memory");
return g;
}

void destroyGrid(grid *g)
{
free(g);
}

void initGrid(grid *g)
{
int x,y;

g->ceiling = 0;

for (x=0;x<XSIZE;x++){
for (y=0;y<YSIZE;y++){
g->cell[x][y] = EMPTY;
}}
}

void hexToSquare(int hx,int hy,int *sx,int *sy)
{
int shift=0;

*sx = hx/(RADIUS*2);
if ((*sy)%2) shift=RADIUS;
*sy = (hy-shift)/(YSTEP*2);

if (*sy >= YSIZE) *sy=YSIZE-1;
}

void shiftDown(grid *g)
{
int x,y;
grid *t;

t = newGrid();
initGrid(t);

g->ceiling++;

for (x=0;x<XSIZE;x++){
for (y=0;y<YSIZE-1;y++){ // don't run over
t->cell[x][y+1] = g->cell[x][y];
t->ceiling = g->ceiling;
}}

for (x=0;x<XSIZE;x++){
for (y=0;y<YSIZE;y++){
g->cell[x][y] = t->cell[x][y];
g->ceiling = t->ceiling;
}}

destroyGrid(t);
}

void checkForEnd(player *p, grid *g)
{
int x,y,end=1;

for(x=0;x<XSIZE;x++){
for(y=0;y<YSIZE;y++){
if (g->cell[x][y]!=EMPTY && g->cell[x][y]!=WALL) end=0;
}}

if (end)
	{
	fprintf(stderr,"\nWell done, you finished in %d shots",p->shots);
	exit(0);
	}
}


