#include <stdio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <stdlib.h>
#include "hex.h"
#include "gtkstuff.h"

GdkPixmap *pixmap=NULL;

void quit(void)
{
exit(-1);
}

GtkWidget *createDrawWindow(int xsize,int ysize,int xoff,int yoff)
{
GtkWidget *window;  
window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_policy((GtkWindow *)window,0,0,1);
gtk_widget_set_uposition(window,xoff,yoff);
gtk_window_set_title((GtkWindow *)window,"Hex");
gtk_signal_connect(GTK_OBJECT(window),"destroy",GTK_SIGNAL_FUNC (quit), NULL);
return window;
} // end create window to draw in.

GtkWidget *createDrawArea(GtkWidget *window,GtkWidget *vbox,int xsize,int ysize)
{
GtkWidget *drawing_area;
drawing_area = gtk_drawing_area_new ();
gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_area), xsize, ysize);
gtk_box_pack_start (GTK_BOX (vbox), drawing_area, TRUE, TRUE, 0);
// Signals used to handle backing pixmap
gtk_signal_connect(GTK_OBJECT (drawing_area), "expose_event",
		  (GtkSignalFunc) expose_event, NULL);
gtk_signal_connect(GTK_OBJECT(drawing_area),"configure_event",
		  (GtkSignalFunc) configure_event, NULL);
// Event signals
/*
if (showButtons)
{
gtk_signal_connect(GTK_OBJECT (drawing_area), "motion_notify_event",
		  (GtkSignalFunc) motion_notify_event, NULL);
gtk_signal_connect(GTK_OBJECT (drawing_area), "button_press_event",
		  (GtkSignalFunc) button_press_event, NULL);
gtk_signal_connect(GTK_OBJECT (drawing_area), "button_release_event",
		  (GtkSignalFunc) button_release_event, NULL);
}
*/
gtk_widget_set_events(drawing_area, GDK_EXPOSURE_MASK
		      | GDK_LEAVE_NOTIFY_MASK
		      | GDK_BUTTON_PRESS_MASK
		      | GDK_BUTTON_RELEASE_MASK
		      | GDK_POINTER_MOTION_MASK
		      | GDK_POINTER_MOTION_HINT_MASK);
gtk_widget_show(drawing_area);
return drawing_area;
} // end create drawing area to draw in.


GtkWidget *createVBox(GtkWidget *window)
{
GtkWidget *vbox;
vbox = gtk_vbox_new(FALSE, 2);
gtk_container_add(GTK_CONTAINER(window),vbox);
gtk_widget_show(vbox);
return vbox;
} // end create vbox for packing

gint expose_event (GtkWidget *widget, GdkEventExpose *event)
{
gdk_draw_pixmap(widget->window,
                widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                pixmap,
                event->area.x, event->area.y,
                event->area.x, event->area.y,
                event->area.width, event->area.height);

return FALSE;
}

gint configure_event (GtkWidget *widget, GdkEventConfigure *event)
{
pixmap = gdk_pixmap_new(widget->window,widget->allocation.width,widget->allocation.height,-1);
gdk_draw_rectangle(pixmap,widget->style->white_gc,TRUE,0,0,widget->allocation.width,widget->allocation.height);
return TRUE;
}

int keyboard_cb(GtkWidget *widget,GdkEventKey *event,gpointer data)
{
GtkWidget *darea;
player *p;
grid *g;
GdkPixmap *back;
GdkRectangle *oldup;

darea = gtk_object_get_data(GTK_OBJECT(data),"darea");
p = gtk_object_get_data(GTK_OBJECT(data),"player");
g = gtk_object_get_data(GTK_OBJECT(data),"grid");
back = gtk_object_get_data(GTK_OBJECT(data),"back");
oldup = gtk_object_get_data(GTK_OBJECT(data),"oldup");

switch(event->keyval)
	{
	case GDK_Left:
        case GDK_KP_Left:
		p->angle+=2;
		if (p->angle>265) p->angle=265;
		back = drawPlayer(darea,p,back,oldup);
		break;
	case GDK_Right:
        case GDK_KP_Right:
		p->angle-=2;
		if (p->angle<95) p->angle=95;
		back = drawPlayer(darea,p,back,oldup);
		break;
	case GDK_space:
	case GDK_KP_Space:
		drawShootPlayer(darea,p,g);
		p->shots++;
		p->currentColour=(rand()%BLUE)+1;
		if (p->shots%COLLAPSETIME == 0) shiftDown(g);
		drawGrid(darea,g);
		checkForEnd(p,g);
		back = drawPlayer(darea,p,back,oldup);
		break;
	}
gtk_object_set_data(GTK_OBJECT(data),"back",back);
return 0;
}

