#define GRAPHICPATH "./graphics/"
#define LEVELPATH "./levels/"

#define XSIZE 8
#define YSIZE 12 // add 1 for the ceiling line

#define COLLAPSETIME 8 // how many shots before ceiling falls

// 8:7 is good. 24:21, 8/7 =approx sqrt(2)
#define RADIUS 24
#define YSTEP 21

#define GRIDWIDTH (RADIUS*XSIZE*2)
#define GRIDHEIGHT ((YSTEP*YSIZE*2+YSTEP/2)-4)

#define EMPTY 0
#define RED 1
#define GREEN 2
#define BLUE 3
#define GREY 4
#define WALL 5
#define GUN 6 // call it a ball, just in the list of sprites
#define BACKGROUND 7
#define CEILING 8
#define NUMBALLS 9

#define PLAYERX (GRIDWIDTH/2)
#define PLAYERY (GRIDHEIGHT+YSTEP*2)
#define PLAYERLEN (YSTEP*4) // looks about right

struct grid
	{
	char cell[XSIZE][YSIZE];
	int ceiling; // 0 for normal, YSIZE-1 for crushed
	};
typedef struct grid grid;

struct player
	{
	int angle;
	int currentColour;
	int shots;
	};
typedef struct player player;

void error(char *s);
grid *newGrid(void);
void destroyGrid(grid *g);
void initGrid(grid *g);
void printGrid(grid *g);
player *newPlayer(void);
void destroyPlayer(player *p);
void initPlayer(player *p);
void printPlayer(player *p);
void loadLevel(grid *g,int level);
void hexToSquare(int hx,int hy,int *sx,int *sy);
void shootPlayer(player *p,grid *g);
int touching(grid *g,int x1,int y1,int x2,int y2);
void checkDrop(grid *g,player *p,int startx,int starty);
void checkMultiple(grid *g,player *p,int oldtx,int oldty,int *xs,int *ys, int *count,int sameColour);
int countTouching(grid *g,int startx,int starty);
void shiftDown(grid *g);
void checkForEnd(player *p, grid *g);
void highlightTouching(grid *g,int startx,int starty);
void listTouching(grid *g,int tx,int ty);
void compactList(int *xs,int *ys,int *origCount);


