#include <stdio.h>
#include <stdlib.h>
#include "hex.h"

void listTouching(grid *g,int tx,int ty)
{
int x,y;
int n;

for(x=tx-1;x<=tx+1;x++){
for(y=ty-1;y<=ty+1;y++){
if (g->cell[x][y]!=EMPTY)
	{
	n=touching(g,x,y,tx,ty);
//	fprintf(stderr,"\nTouching Number: %d",n);
	}
}}
}

int countTouching(grid *g,int startx,int starty)
{
int x,y,i=0;
int n;
int j;

for (x=startx-1;x<=startx+1;x++){
for (y=starty-1;y<=starty+1;y++){
	if (g->ceiling%2) n = !(y%2); else n = (y%2);
	if (x>=0 && y>=0 && x<XSIZE-n && y<YSIZE)
		{
		if (g->cell[x][y]!=EMPTY && (j=touching(g,startx,starty,x,y)>0))
			{
			//fprintf(stderr,"\ncounted: %d",j);
			i++;
			}
		}
}}
if (i>6) error("Too much touching");
return i;
}

void highlightTouching(grid *g,int startx,int starty)
{
int x,y;
grid *t;

fprintf(stderr,"\nHighlight touching: %d,%d",startx,starty);

t = newGrid();
initGrid(t);

for (x=0;x<XSIZE;x++){
for (y=0;y<YSIZE;y++){ // don't run over
t->cell[x][y] = g->cell[x][y];
t->ceiling = g->ceiling;
}}

for (x=startx-10;x<=startx+10;x++){
for (y=starty-10;y<=starty+10;y++){
if (touching(g,startx,starty,x,y)>0) t->cell[x][y]=GREY;
}}

//printGrid(t);
//usleep(65535);
//sleep(2);

destroyGrid(t);
}

void checkDrop(grid *g,player *p,int startx,int starty)
{
int i,j;
int x,y;
int xs[(XSIZE*YSIZE)*(XSIZE*YSIZE)];
int ys[(XSIZE*YSIZE)*(XSIZE*YSIZE)];
int count;
int stuck;
int n;

for (y=0;y<YSIZE;y++){ // one less on odd rows
if (g->ceiling%2) n = !(y%2); else n = (y%2);
for (x=0;x<XSIZE-n;x++)
	{
	if (g->cell[x][y]!=EMPTY)
	{
	count = 0;
	checkMultiple(g,p,x,y,xs,ys,&count,0);
	if (count)
		{
		stuck = 0;
		for (i=0;i<count;i++) if (ys[i] == g->ceiling) stuck=1;
		if (!stuck)
			{
			for (j=0;j<count;j++)
				{
				if (ys[j] == g->ceiling) error("ug1");
//				fprintf(stderr,"\nRemove %d,%d",xs[j],ys[j]);
				g->cell[xs[j]][ys[j]] = EMPTY;
				}
			}
		}
	}
	if (g->cell[x][y]!=EMPTY && countTouching(g,x,y)==0 && y>g->ceiling)
		{
//		fprintf(stderr,"\nRemove: %d,%d",x,y);
		g->cell[x][y]=EMPTY; // clean up strays
		checkDrop(g,p,startx,starty); // look for more
		}
}
}
}

void checkMultiple(grid *g,player *p,int oldtx,int oldty,int *xs,int *ys, int *count,int sameColour)
{
int x,y;
int i,j;
int f;
int n;

for (x=oldtx-1;x<=oldtx+1;x++){
for (y=oldty-1;y<=oldty+1;y++){
//fprintf(stderr,"\n%d,%d",x,y);
if (sameColour) // must be the same colour
        { 
        f = (g->cell[x][y]==g->cell[oldtx][oldty]);     
        } 
else f=1;

if (g->ceiling%2) n = !(y%2); else n = (y%2);
if ((x<XSIZE-n && y<YSIZE && x>=0 && y>=0) && f && touching(g,oldtx,oldty,x,y)>0 && g->cell[x][y]!=EMPTY)
	{
	xs[*count] = x; // store current collision
	ys[*count] = y;
	(*count)++;
//	fprintf(stderr,"\nTouching: %d,%d",x,y);

	j=0; // check if x,y is already in list to be removed
       	for (i=0;i<(*count)-1;i++)
               	{
 //              	if ((xs[i]==x && ys[i]==y)||(xs[i]==oldtx && ys[i]==oldty))
                if ((xs[i]==x && ys[i]==y))
                     	{
//                       	fprintf(stderr,"\nAlready in list");
                       	j=1;
                       	}
               	}       
	if (!j)
		{
		compactList(xs,ys,count);
		checkMultiple(g,p,x,y,xs,ys,count,sameColour);
		}
	}
	}}
}

void compactList(int *xs,int *ys,int *origCount)
{
// this is so bad it makes me cry. This function saves on a bit of memory, but takes a billion cycles to complete. Need to find a nice one from Knuth or something for removing duplicates from lists.

int newxs[500];
int newys[500];
int newcount;
int count;
int i,j;
int found;

count=*origCount;
if (count>=500) error("Bugger me backwards with a fishfork");

newcount=0;
for(i=0;i<count;i++)
	{
	found = 0;
	for (j=0;j<i;j++)
		{
		if (newxs[j] == xs[i] && newys[j] == ys[i])
			{
			found = 1; // break
			}
		}
	if (!found)
		{
		newxs[newcount] = xs[i];
		newys[newcount] = ys[i];
		newcount++;
		}
	}
//fprintf(stderr,"\nnewcount: %d\ncount: %d",newcount,count);

for(i=0;i<newcount;i++) // copy back
	{
	xs[i] = newxs[i];
	ys[i] = newys[i];
	}
*origCount = newcount;
}

int touching(grid *g,int x1,int y1,int x2,int y2)
{
int n;

// this works!!!!!!! OMIGOD

if (!(g->ceiling%2))
{
if (y1%2) n=1;
else n=-1;
}
else
{
if (y1%2) n=-1;
else n=1;
}

//fprintf(stderr,"\nx1,y1 = %d,%d\nx2,y2 = %d,%d",x1,y1,x2,y2);
if (x1<0 || y1<0 || x2<0 || y2<0) return -2;
if (x1>XSIZE-n || x2>XSIZE-n || y1>YSIZE-1 || y2>YSIZE-1) return -1;
if (x1==x2 && y1==y2) return -3;

if (x1+n==x2 && y1-1==y2) return 1;
if (x1==x2 && y1-1==y2) return 2;
if (x1-1==x2 && y1==y2) return 3;
if (x1+1==x2 && y1==y2) return 4;
if (x1+n==x2 && y1+1==y2) return 5;
if (x1==x2 && y1+1==y2) return 6;
return 0;
}


